﻿using System;
using System.Windows;
using System.Data;
using System.Xml;
using System.Configuration;
using System.Diagnostics;

namespace mates_viz
{
    /// <summary>
    /// Interaction logic for MyApp.xaml
    /// </summary>

    public partial class MyApp : Application
    {
               
        UI mainWindow;
        MatesController myController;

        void AppStartingUp(object sender, StartingUpCancelEventArgs e)
        {
            
            //Window1 mainWindow = new Window1();
            //mainWindow.Show();

            Error.PrepareLog();

            mainWindow = new UI();
            mainWindow.Show();

            // tell me when the window is loaded
            mainWindow.Loaded += new EventHandler(mainWindow_Loaded);
           
        }

        void mainWindow_Loaded(object sender, EventArgs e)
        {
            // now that the UI is ready, instantiate a controller
            myController = new MatesController(mainWindow);

        }

    }
}